git-am.shon commit Merge branch 'bs/maint-commit-options' (b2e1632)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005, 2006 Junio C Hamano
   4
   5USAGE='[--signoff] [--dotest=<dir>] [--keep] [--utf8 | --no-utf8]
   6  [--3way] [--interactive] [--binary]
   7  [--whitespace=<option>] [-C<n>] [-p<n>]
   8  <mbox>|<Maildir>...
   9  or, when resuming [--skip | --resolved]'
  10. git-sh-setup
  11set_reflog_action am
  12require_work_tree
  13
  14git var GIT_COMMITTER_IDENT >/dev/null || exit
  15
  16stop_here () {
  17    echo "$1" >"$dotest/next"
  18    exit 1
  19}
  20
  21stop_here_user_resolve () {
  22    if [ -n "$resolvemsg" ]; then
  23            printf '%s\n' "$resolvemsg"
  24            stop_here $1
  25    fi
  26    cmdline=$(basename $0)
  27    if test '' != "$interactive"
  28    then
  29        cmdline="$cmdline -i"
  30    fi
  31    if test '' != "$threeway"
  32    then
  33        cmdline="$cmdline -3"
  34    fi
  35    if test '.dotest' != "$dotest"
  36    then
  37        cmdline="$cmdline -d=$dotest"
  38    fi
  39    echo "When you have resolved this problem run \"$cmdline --resolved\"."
  40    echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
  41
  42    stop_here $1
  43}
  44
  45go_next () {
  46        rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
  47                "$dotest/patch" "$dotest/info"
  48        echo "$next" >"$dotest/next"
  49        this=$next
  50}
  51
  52cannot_fallback () {
  53        echo "$1"
  54        echo "Cannot fall back to three-way merge."
  55        exit 1
  56}
  57
  58fall_back_3way () {
  59    O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
  60
  61    rm -fr "$dotest"/patch-merge-*
  62    mkdir "$dotest/patch-merge-tmp-dir"
  63
  64    # First see if the patch records the index info that we can use.
  65    git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
  66        "$dotest/patch" &&
  67    GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
  68    git write-tree >"$dotest/patch-merge-base+" ||
  69    cannot_fallback "Repository lacks necessary blobs to fall back on 3-way merge."
  70
  71    echo Using index info to reconstruct a base tree...
  72    if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
  73        git apply $binary --cached <"$dotest/patch"
  74    then
  75        mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
  76        mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
  77    else
  78        cannot_fallback "Did you hand edit your patch?
  79It does not apply to blobs recorded in its index."
  80    fi
  81
  82    test -f "$dotest/patch-merge-index" &&
  83    his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
  84    orig_tree=$(cat "$dotest/patch-merge-base") &&
  85    rm -fr "$dotest"/patch-merge-* || exit 1
  86
  87    echo Falling back to patching base and 3-way merge...
  88
  89    # This is not so wrong.  Depending on which base we picked,
  90    # orig_tree may be wildly different from ours, but his_tree
  91    # has the same set of wildly different changes in parts the
  92    # patch did not touch, so recursive ends up canceling them,
  93    # saying that we reverted all those changes.
  94
  95    eval GITHEAD_$his_tree='"$SUBJECT"'
  96    export GITHEAD_$his_tree
  97    git-merge-recursive $orig_tree -- HEAD $his_tree || {
  98            git rerere
  99            echo Failed to merge in the changes.
 100            exit 1
 101    }
 102    unset GITHEAD_$his_tree
 103}
 104
 105prec=4
 106dotest=.dotest sign= utf8=t keep= skip= interactive= resolved= binary=
 107resolvemsg= resume=
 108git_apply_opt=
 109
 110while test $# != 0
 111do
 112        case "$1" in
 113        -d=*|--d=*|--do=*|--dot=*|--dote=*|--dotes=*|--dotest=*)
 114        dotest=`expr "z$1" : 'z-[^=]*=\(.*\)'`; shift ;;
 115        -d|--d|--do|--dot|--dote|--dotes|--dotest)
 116        case "$#" in 1) usage ;; esac; shift
 117        dotest="$1"; shift;;
 118
 119        -i|--i|--in|--int|--inte|--inter|--intera|--interac|--interact|\
 120        --interacti|--interactiv|--interactive)
 121        interactive=t; shift ;;
 122
 123        -b|--b|--bi|--bin|--bina|--binar|--binary)
 124        binary=t; shift ;;
 125
 126        -3|--3|--3w|--3wa|--3way)
 127        threeway=t; shift ;;
 128        -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
 129        sign=t; shift ;;
 130        -u|--u|--ut|--utf|--utf8)
 131        utf8=t; shift ;; # this is now default
 132        --no-u|--no-ut|--no-utf|--no-utf8)
 133        utf8=; shift ;;
 134        -k|--k|--ke|--kee|--keep)
 135        keep=t; shift ;;
 136
 137        -r|--r|--re|--res|--reso|--resol|--resolv|--resolve|--resolved)
 138        resolved=t; shift ;;
 139
 140        --sk|--ski|--skip)
 141        skip=t; shift ;;
 142
 143        --whitespace=*|-C*|-p*)
 144        git_apply_opt="$git_apply_opt $1"; shift ;;
 145
 146        --resolvemsg=*)
 147        resolvemsg=${1#--resolvemsg=}; shift ;;
 148
 149        --)
 150        shift; break ;;
 151        -*)
 152        usage ;;
 153        *)
 154        break ;;
 155        esac
 156done
 157
 158# If the dotest directory exists, but we have finished applying all the
 159# patches in them, clear it out.
 160if test -d "$dotest" &&
 161   last=$(cat "$dotest/last") &&
 162   next=$(cat "$dotest/next") &&
 163   test $# != 0 &&
 164   test "$next" -gt "$last"
 165then
 166   rm -fr "$dotest"
 167fi
 168
 169if test -d "$dotest"
 170then
 171        case "$#,$skip$resolved" in
 172        0,*t*)
 173                # Explicit resume command and we do not have file, so
 174                # we are happy.
 175                : ;;
 176        0,)
 177                # No file input but without resume parameters; catch
 178                # user error to feed us a patch from standard input
 179                # when there is already .dotest.  This is somewhat
 180                # unreliable -- stdin could be /dev/null for example
 181                # and the caller did not intend to feed us a patch but
 182                # wanted to continue unattended.
 183                tty -s
 184                ;;
 185        *)
 186                false
 187                ;;
 188        esac ||
 189        die "previous dotest directory $dotest still exists but mbox given."
 190        resume=yes
 191else
 192        # Make sure we are not given --skip nor --resolved
 193        test ",$skip,$resolved," = ,,, ||
 194                die "Resolve operation not in progress, we are not resuming."
 195
 196        # Start afresh.
 197        mkdir -p "$dotest" || exit
 198
 199        git mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" ||  {
 200                rm -fr "$dotest"
 201                exit 1
 202        }
 203
 204        # -b, -s, -u, -k and --whitespace flags are kept for the
 205        # resuming session after a patch failure.
 206        # -3 and -i can and must be given when resuming.
 207        echo "$binary" >"$dotest/binary"
 208        echo " $ws" >"$dotest/whitespace"
 209        echo "$sign" >"$dotest/sign"
 210        echo "$utf8" >"$dotest/utf8"
 211        echo "$keep" >"$dotest/keep"
 212        echo 1 >"$dotest/next"
 213fi
 214
 215case "$resolved" in
 216'')
 217        files=$(git diff-index --cached --name-only HEAD) || exit
 218        if [ "$files" ]; then
 219           echo "Dirty index: cannot apply patches (dirty: $files)" >&2
 220           exit 1
 221        fi
 222esac
 223
 224if test "$(cat "$dotest/binary")" = t
 225then
 226        binary=--allow-binary-replacement
 227fi
 228if test "$(cat "$dotest/utf8")" = t
 229then
 230        utf8=-u
 231else
 232        utf8=-n
 233fi
 234if test "$(cat "$dotest/keep")" = t
 235then
 236        keep=-k
 237fi
 238ws=`cat "$dotest/whitespace"`
 239if test "$(cat "$dotest/sign")" = t
 240then
 241        SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
 242                        s/>.*/>/
 243                        s/^/Signed-off-by: /'
 244                `
 245else
 246        SIGNOFF=
 247fi
 248
 249last=`cat "$dotest/last"`
 250this=`cat "$dotest/next"`
 251if test "$skip" = t
 252then
 253        git rerere clear
 254        this=`expr "$this" + 1`
 255        resume=
 256fi
 257
 258if test "$this" -gt "$last"
 259then
 260        echo Nothing to do.
 261        rm -fr "$dotest"
 262        exit
 263fi
 264
 265while test "$this" -le "$last"
 266do
 267        msgnum=`printf "%0${prec}d" $this`
 268        next=`expr "$this" + 1`
 269        test -f "$dotest/$msgnum" || {
 270                resume=
 271                go_next
 272                continue
 273        }
 274
 275        # If we are not resuming, parse and extract the patch information
 276        # into separate files:
 277        #  - info records the authorship and title
 278        #  - msg is the rest of commit log message
 279        #  - patch is the patch body.
 280        #
 281        # When we are resuming, these files are either already prepared
 282        # by the user, or the user can tell us to do so by --resolved flag.
 283        case "$resume" in
 284        '')
 285                git mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
 286                        <"$dotest/$msgnum" >"$dotest/info" ||
 287                        stop_here $this
 288
 289                # skip pine's internal folder data
 290                grep '^Author: Mail System Internal Data$' \
 291                        <"$dotest"/info >/dev/null &&
 292                        go_next && continue
 293
 294                test -s $dotest/patch || {
 295                        echo "Patch is empty.  Was it split wrong?"
 296                        stop_here $this
 297                }
 298                git stripspace < "$dotest/msg" > "$dotest/msg-clean"
 299                ;;
 300        esac
 301
 302        GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
 303        GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
 304        GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
 305
 306        if test -z "$GIT_AUTHOR_EMAIL"
 307        then
 308                echo "Patch does not have a valid e-mail address."
 309                stop_here $this
 310        fi
 311
 312        export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
 313
 314        SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
 315        case "$keep_subject" in -k)  SUBJECT="[PATCH] $SUBJECT" ;; esac
 316
 317        case "$resume" in
 318        '')
 319            if test '' != "$SIGNOFF"
 320            then
 321                LAST_SIGNED_OFF_BY=`
 322                    sed -ne '/^Signed-off-by: /p' \
 323                    "$dotest/msg-clean" |
 324                    tail -n 1
 325                `
 326                ADD_SIGNOFF=`
 327                    test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
 328                    test '' = "$LAST_SIGNED_OFF_BY" && echo
 329                    echo "$SIGNOFF"
 330                }`
 331            else
 332                ADD_SIGNOFF=
 333            fi
 334            {
 335                printf '%s\n' "$SUBJECT"
 336                if test -s "$dotest/msg-clean"
 337                then
 338                        echo
 339                        cat "$dotest/msg-clean"
 340                fi
 341                if test '' != "$ADD_SIGNOFF"
 342                then
 343                        echo "$ADD_SIGNOFF"
 344                fi
 345            } >"$dotest/final-commit"
 346            ;;
 347        *)
 348                case "$resolved$interactive" in
 349                tt)
 350                        # This is used only for interactive view option.
 351                        git diff-index -p --cached HEAD >"$dotest/patch"
 352                        ;;
 353                esac
 354        esac
 355
 356        resume=
 357        if test "$interactive" = t
 358        then
 359            test -t 0 ||
 360            die "cannot be interactive without stdin connected to a terminal."
 361            action=again
 362            while test "$action" = again
 363            do
 364                echo "Commit Body is:"
 365                echo "--------------------------"
 366                cat "$dotest/final-commit"
 367                echo "--------------------------"
 368                printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
 369                read reply
 370                case "$reply" in
 371                [yY]*) action=yes ;;
 372                [aA]*) action=yes interactive= ;;
 373                [nN]*) action=skip ;;
 374                [eE]*) git_editor "$dotest/final-commit"
 375                       action=again ;;
 376                [vV]*) action=again
 377                       LESS=-S ${PAGER:-less} "$dotest/patch" ;;
 378                *)     action=again ;;
 379                esac
 380            done
 381        else
 382            action=yes
 383        fi
 384
 385        if test $action = skip
 386        then
 387                go_next
 388                continue
 389        fi
 390
 391        if test -x "$GIT_DIR"/hooks/applypatch-msg
 392        then
 393                "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
 394                stop_here $this
 395        fi
 396
 397        printf 'Applying %s\n' "$SUBJECT"
 398
 399        case "$resolved" in
 400        '')
 401                git apply $git_apply_opt $binary --index "$dotest/patch"
 402                apply_status=$?
 403                ;;
 404        t)
 405                # Resolved means the user did all the hard work, and
 406                # we do not have to do any patch application.  Just
 407                # trust what the user has in the index file and the
 408                # working tree.
 409                resolved=
 410                git diff-index --quiet --cached HEAD && {
 411                        echo "No changes - did you forget to use 'git add'?"
 412                        stop_here_user_resolve $this
 413                }
 414                unmerged=$(git ls-files -u)
 415                if test -n "$unmerged"
 416                then
 417                        echo "You still have unmerged paths in your index"
 418                        echo "did you forget to use 'git add'?"
 419                        stop_here_user_resolve $this
 420                fi
 421                apply_status=0
 422                git rerere
 423                ;;
 424        esac
 425
 426        if test $apply_status = 1 && test "$threeway" = t
 427        then
 428                if (fall_back_3way)
 429                then
 430                    # Applying the patch to an earlier tree and merging the
 431                    # result may have produced the same tree as ours.
 432                    git diff-index --quiet --cached HEAD && {
 433                        echo No changes -- Patch already applied.
 434                        go_next
 435                        continue
 436                    }
 437                    # clear apply_status -- we have successfully merged.
 438                    apply_status=0
 439                fi
 440        fi
 441        if test $apply_status != 0
 442        then
 443                echo Patch failed at $msgnum.
 444                stop_here_user_resolve $this
 445        fi
 446
 447        if test -x "$GIT_DIR"/hooks/pre-applypatch
 448        then
 449                "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
 450        fi
 451
 452        tree=$(git write-tree) &&
 453        parent=$(git rev-parse --verify HEAD) &&
 454        commit=$(git commit-tree $tree -p $parent <"$dotest/final-commit") &&
 455        git update-ref -m "$GIT_REFLOG_ACTION: $SUBJECT" HEAD $commit $parent ||
 456        stop_here $this
 457
 458        if test -x "$GIT_DIR"/hooks/post-applypatch
 459        then
 460                "$GIT_DIR"/hooks/post-applypatch
 461        fi
 462
 463        git gc --auto
 464
 465        go_next
 466done
 467
 468rm -fr "$dotest"